# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc补货设置更新功能验证,31,31-24,sit,bs
主数据平台:后台运营系统补货设置更新接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import random
import requests
import json

module = "cmdc_31st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取补货单设置信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url15")
request_body = commonFuc().get_business_data(module, "payload27_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)

# 获取补货设置信息
id = result["data"]["list"][0]["id"]
supplier_code = result["data"]["list"][0]["supplierCode"]
supplier_name = result["data"]["list"][0]["supplierName"]

# 第三步获取合同协议号
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url25")
request_body = commonFuc().get_business_data(module, "payload25")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
vpt_random = random.randint(0, len(result["data"]))
# 获取合同信息
if result["data"][vpt_random]["tcacatt1DS"]:
    pac_no = result["data"][vpt_random]["tcacatt1DS"]
    project_code = result["data"][vpt_random]["tcir02"]
    project_name = result["data"][vpt_random]["tcdl011"]
    salesman_name = result["data"][vpt_random]["tcacatt4DS"]
    business_department_name = result["data"][vpt_random]["tcalph"]

    # 第四步补货设置信息更新操作
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url27")
    request_body = commonFuc().get_business_data(module, "payload27", id, pac_no, supplier_code, supplier_name,
                                                 project_name, project_code, salesman_name, business_department_name)
    # print(request_body)
    """
    
     场景: 补货设置更新功能验证
     用例名称：补货设置更新功能验证
     输出：{"pacNo":"%s"}
    """

    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 断言实际结果
    result = {"pacNo": pac_no}
    # print(result)
    result["api_time"] = api_time

    # 数据库操作
    mysql_handle = mySql()
    # 获取conf.ini文件中配置的数据库信息
    host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

    # 查询数据库中新增补货设置对应的pacNo
    sql = "SELECT t.pacNo FROM `cmdc-order`.tc_replenishment_setting t WHERE productCode = 10154719 and deleteSign = 0"
    pac_no = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict27", pac_no)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
