# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取需求单详情信息,2295,2295-94,sit,bs
主数据平台:后台运营系统获取需求单详情信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import requests
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取需求单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_list")
request_body = commonFuc().get_business_data(module, "payload_list")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
demand_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取需求单信息
demandId = result["data"]["list"][demand_random]["demandId"]

# 第三步获取需求单详情信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url94")
request_body = commonFuc().get_business_data(module, "payload94", demandId)

"""

 场景: 获取需求单详情信息
 用例名称：获取需求单详情信息
 输出：{"demandId":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取需求单详情信息
result = json.loads(result.content)
result = {"demandId": result["data"]["demandId"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict94", demandId)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)