# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_商品列表,2293,2293-004,sit,bs
主数据平台:后台运营系统商品列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_product"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取商品列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)


# 此函数用于当x为none时，进行空字符串替换
def func(x):
    if x is None:
        x = ""
        return x
    else:
        return x


# 生成一个随机数字，用于后续随机选择某一条商品信息
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取商品信息
product_code = result["data"]["list"][rebate_random]["productCode"]
product_name = func(result["data"]["list"][rebate_random]["productName"])
specifications = result["data"]["list"][rebate_random]["specifications"]
manufacturer = func(result["data"]["list"][rebate_random]["manufacturer"])
start_time = func(result["data"]["list"][rebate_random]["uploadTime"])

# 获取当前时间作为创建时间和最近修改时间截止时间
end_time = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')

# 第三步进行条件查询验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url4")
request_body = commonFuc().get_business_data(module, "payload4", product_name, product_code, specifications,
                                             manufacturer)
# print(request_body)
"""

 场景: 验证商品列表查询条件是否可以正常使用
 用例名称：列表查询条件验证_商品列表
 输出：{"productCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
# 获取查询结果中商品code
result = {"productCode": result["data"]["list"][0]["productCode"]}
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict4", product_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
