# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_产品线商品,2271,2271-28,sit,bs
主数据平台:后台运营系统产品线商品查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取产品线商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url15")
request_body = commonFuc().get_business_data(module, "payload15")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数字，用于后续随机选择商品
product_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取产品线商品列表中商品信息
product_name = result["data"]["list"][product_random]["relevanceName"]
product_code = result["data"]["list"][product_random]["relevanceCode"]

# 第三步进行条件查询验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url16")
request_body = commonFuc().get_business_data(module, "payload16", product_name, product_code)

"""

 场景: 验证产品线商品列表查询条件是否可以正常使用
 用例名称：列表查询条件验证_产品线商品
 输出：{"relevanceCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
# 获取查询结果中商品对应的商品code
result = {"relevanceCode": result["data"]["list"][0]["relevanceCode"]}
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict16", product_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

